<?php
namespace Teknisa\CMP\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class ValidaFilialService {
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function retornaListaDeFiliais($P_CDOPERADOR) {
        $param = array();
        $param["P_CDOPERADOR"] = $P_CDOPERADOR;
        
        $query = "SELECT
                    FILIAL.CDFILIAL
                FROM
                    FILIAL,
                    PARAMGERAL
                WHERE
                    FILIAL.CDREGIAO IS NOT NULL
                    AND NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
                    AND ( ( NVL(PARAMGERAL.IDRESTRFILIOPER, 'N') = 'N' )
                    OR ( EXISTS (
                        SELECT
                            1
                        FROM
                            FILIOPER F
                        WHERE
                            F.CDFILIAL = FILIAL.CDFILIAL
                            AND F.CDOPERADOR = :P_CDOPERADOR
                    ) ) )
                ORDER BY
                    FILIAL.CDFILIAL";
                    
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
}